/* $Id: Pitch2.java,v 1.3 2011/10/11 06:14:22 mit Exp $ :/
/* Pitch2.java v0.2 */
import java.text.DecimalFormat;

public class Pitch2 {
    private int count;   // ԡβ
    private int keyn;    // #
    private double freq; // ԡμȿ()
    private String name; // ̾
    private static int counter; // ԡ

    private final int OCT = 12;
    private final String [] Keynm =
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    private DecimalFormat df1 = new DecimalFormat("#0.0##");

    public Pitch2() {}
    public Pitch2(Peaks ps) {
	setPitch(ps);
    }
    public boolean isPitch(Peaks ps) {
	if (ps == null)
	    return false;
        return (ps.getPeaksK() == keyn) ? true : false;
    }
    public void setPitch(Peaks ps) {
	if (count < 1) {
            keyn = ps.getPeaksK();
	    name = this.getKeyName();
            ++counter;
        }

	freq += ps.getPeaksF();
	count++;
    }
    public String toString() {
        StringBuilder str = new StringBuilder(128);

        str.append(name);
        str.append("["+count+"]: ");
        str.append(df1.format((float)this.getPfreq()));
        
        return str.toString();
    }
    public static void resetPcounter() {
        counter = 0;
    }
    public static int getPcounter() {
        return counter;
    }
    public String getPname() {
        return name;
    }
    public int getPkey() {
        return keyn;
    }
    public double getPfreq() {
        return freq/count;   // ʿͤФ
    }
    public int getPcount() {
        return count;
    }
    public String getKeyName() {
	int kn = keyn%OCT;
	if (kn < 0)
	    return "";
        return (keyn+1)+Keynm[kn];
    }
}