/* $Id: Peaks.java,v 1.2 2011/09/17 08:39:12 mit Exp $ */
/* Peaks.java v0.1 */
import java.text.DecimalFormat;

public class Peaks {
    private int key;     // #
    private int count;   // 롼Ǥν
    private double freq; // ԡȿ

    private DecimalFormat df1 = new DecimalFormat("#0.0##");

    public Peaks() {
	setPeaks(0, 0, 0);
    }
    public Peaks(int ky, int nm, double fr) {
	setPeaks(ky, nm, fr);
    }
    public void setPeaks(int ky, int nm, double fq) {
	key = ky;
	count = nm;
	freq = fq;
    }
    public void resetPeaks(double fq) {
	freq = (freq+fq)/2; // Ʊʤʿͤ
    }
    public boolean isPeaks(Peaks ps) {
	return (ps.getPeaksK() == key) ? true : false;
    }
    public String toString() {
        StringBuilder  str = new StringBuilder(64);

        str.append("Key#:"+key);
	str.append("Count:"+count);
	str.append("Freq.:"+df1.format((float)freq));

	return str.toString();
    }
    //
    public int getPeaksK() {
	return key;
    }
    public int getPeaksC() {
	return count;
    }
    public double getPeaksF() {
	return freq;
    }
}